<script>
import { format } from "date-fns";

export default {
  props: {
    mine: {
      type: Number,
    },

    message: {
      type: Object,
      required: true,
    },

    members: {
      type: Array,
      required: true,
    },
  },

  computed: {
    formattedName() {
      return this.mine === this.message.member_id
        ? "Вы"
        : this.members.find((member) => {
            return this.message.member_id === member.id;
          }).member.user.name;
    },

    formattedDate() {
      return format(new Date(this.message.created_at), "HH:mm");
    },

    formattedImagePath() {
      return this.mine === this.message.member_id
        ? this.user?.avatar !== null
          ? this.user?.avatar?.url?.full_size
          : require("../assets/logo.svg")
        : this.members.find((member) => {
            return this.message.member_id === member.id;
          }).member.user?.avatar !== null
        ? this.members.find((member) => {
            return this.message.member_id === member.id;
          }).member.user?.avatar?.url?.full_size
        : require("../assets/logo.svg");
    },
  },
};
</script>

<template>
  <div
    class="chat-message"
    :class="{ 'chat-message_mine': mine === message.member_id }"
  >
    <div class="chat-message__img">
      <img :src="formattedImagePath" width="25" alt="" />
    </div>

    <div class="chat-message__info">
      <span>{{ formattedDate }}</span>

      <h6>{{ formattedName }}</h6>
      <p>{{ message.message }}</p>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.chat-message {
  display: flex;
  align-items: flex-end;
  margin-bottom: 24px;

  &_mine {
    justify-content: flex-end;

    .chat-message__info {
      background-color: #5abaed;
    }

    .chat-message__img {
      display: none;
    }
  }

  &__img {
    display: flex;
    margin-right: 8px;
    max-height: 30px;
    max-width: 30px;

    img {
      border-radius: 4px;
      width: 100%;
      height: auto;
    }
  }

  &__info {
    background-color: #179de3;
    position: relative;
    padding: 16px;
    border-radius: 4px;
    max-width: 290px;
    min-width: 140px;

    span {
      position: absolute;
      right: 8px;
      top: 8px;
      font-size: 10px;
      color: #fff;
      opacity: 0.5;
    }

    h6 {
      font-size: 14px;
      font-weight: 500;
      color: #fff;
    }

    p {
      font-size: 14px;
      color: #f3f7ff;
    }
  }
}
</style>
